<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Editor Projektionswege</title>
    <script src="/assets/js/jsoneditor.min.js"></script>
    <script src="/assets/js/randomColor.min.js"></script>
    <link href="/assets/css/reset.min.css" rel="stylesheet">
    <link rel="stylesheet" href="/assets/css/fonts_googleapis_Frank_Ruhl_Libre_Source_Sans_Pro.css">

    <link href="/assets/css/projektionswege.css" type="text/css" rel="stylesheet" />
  </head>
  <body>
    <div id="page-wrapper" class="grid-container">
      <h1 class="grid-title">Projektionswege</h1>
      <div class="grid-button-add" id="addpath" onclick="addPath();">Add Path</div>
    </div>

    <div id="overlay" class="overlay"></div>
    <div id="overlay-editor" class="overlay-editor">
      <div id="editor_holder"></div>
      <br />
      <span id="valid_indicator" class="grid-valid"></span>
    </div>

    <script>
      var gridRowsRegion = [];
      var data = [];
      var id = false;
      var pw = false;

      // Load Path Headers from JSON Schema
      var jsonSchema;
      var vh;
      var pathHeaders = "";

      fetch("../api/schema-pw")
        .then(function(response) {
          return response.json();
        })
        .then(function(schema) {
          jsonSchema = schema;
        })
        .then(function() {
          getVegetationshöhenstufen();
        })
        .then(function() {
          fetchData();
        });

      // Load Path Segments from JSON
      function fetchData() {
        data = 0;
        fetch("../api/projektionswege")
          .then(function(response) {
            return response.json();
          })
          .then(function(myJson) {
            data = myJson;
          })
          .then(function() {
            console.log(data);
          })
          .then(function() {
            gridRows();
          })
          .then(function() {
            drawGrid();
          });
      }

      // Parse Path Headers from JSON Schema and draw to DOM
      function getVegetationshöhenstufen() {
        vh = jsonSchema.items.properties.vhIst.enum;
        for (var i = 0; i < vh.length; i++) {
          var n = i + 2;
          pathHeaders +=
            '<div class="pathHeader" style="grid-area: 2 / ' + n + " / 2 / " + n + ';">' + vh[i] + "</div>";
        }
        document.getElementById("page-wrapper").innerHTML += pathHeaders;
      }

      // Parse Grid Rows from JSON Data and draw to DOM
      function gridRows() {
        var staging = "",
          row;
        for (var n in data) {
          var region = "";
          for (var key in data[n].region) {
            if (data[n].region[key]) {
              region += String(key) + " ";
            }
          }
          if (gridRowsRegion.includes(region) === false) {
            gridRowsRegion.push(region);
          }
        }

        gridRowsRegion = gridRowsRegion.sort();

        for (var key in gridRowsRegion) {
          row = 0;
          staging = "";
          row = Number(key) + 3;
          staging +=
            '<div class="region" style="grid-area: ' +
            row +
            " / 1 / " +
            row +
            ' / 1;">' +
            gridRowsRegion[key] +
            "</div>";
          document.getElementById("page-wrapper").innerHTML += staging;
        }
      }

      // Parse Path Segments from JSON and draw to path grid
      function drawGrid() {
        for (var n in data) {
          var column,
            columnPlus,
            newline,
            vh,
            region = "",
            existingRegions,
            bedingung = "",
            staging = "",
            row;

          // css vaild id
          pw = "pw" + ("000" + n).substr(-3);
          console.log(pw);
          // pw = Number(pw.substr(2));
          // console.log(pw)

          // Read region
          for (var key in data[n].region) {
            if (data[n].region[key]) {
              region += String(key) + " ";
            }
          }

          // set row to row in gridrowregions
          row = gridRowsRegion.indexOf(region);
          row = row + 3;

          // if (gridRowsRegion.includes(region)) {
          //     newline = false;
          // row = gridRowsRegion.indexOf(region)
          // row = row + 4
          //     // console.log('not added to region rows:')
          // } else {
          //     gridRowsRegion.push(region);
          //     newline = true;
          //     // console.log('added to region rows:')
          // };
          var c = randomColor({ hue: "orange", luminosity: "light" }); //hue: 'green',
          console.log(c);

          // check in welcher spalte das pfadsegment beginnt
          vh = jsonSchema.items.properties.vhIst.enum;
          for (var i = 0; i < vh.length; i++) {
            if (data[n].vhIst == vh[i]) {
              column = i + 2;
              // console.log('got the column number, it is number: ' + column);
            }
          }
          for (var i = 0; i < vh.length; i++) {
            if (data[n].vhNeu == vh[i]) {
              columnPlus = i + 2;
              // console.log('got the columnPlus number, it is number: ' + columnPlus);
            }
          }

          // concat bedingungen to single string
          bedingung += '<div id="' + pw + '">' + data[n].incl + "°";
          if (data[n].misc.fir !== "false") {
            bedingung += ", " + data[n].misc.fir;
          }
          if (data[n].misc.relief !== "false") {
            bedingung += ", " + data[n].misc.relief;
          }
          if (data[n].misc.weitere !== "false") {
            bedingung += ", " + data[n].misc.weitere;
          }
          bedingung += "</div>";
          // console.log('bedingungen: ' + bedingung)

          // draw pathsegment to grid
          staging +=
            '<div id="' +
            pw +
            '" onclick="editData(event)" class="path-segment ' +
            n +
            '" style="grid-area: ' +
            row +
            " / " +
            column +
            " / " +
            row +
            " / " +
            columnPlus +
            "; background-color:" +
            c +
            ';">';
          staging += '<div id="' + pw + '" class="wg-ist ' + n + '">' + data[n].wgIst + "</div>";
          staging += '<div id="' + pw + '" class="misc ' + n + '">' + bedingung + "</div>";
          staging += '<div id="' + pw + '" class="wg-neu ' + n + '">' + data[n].wgNeu + "</div></div>";
          document.getElementById("page-wrapper").innerHTML += staging;
        }
        console.log("gridDrawn");
      }

      // Initalize Json-Editor
      var editor = new JSONEditor(document.getElementById("editor_holder"), {
        // Enable fetching schemas via ajax
        ajax: true,

        // Set css theme
        theme: "bootstrap4",
        iconlib: "none",

        // The schema for the editor
        schema: { $ref: "../api/schema-pw" },

        // Disable collapse
        disable_collapse: true,

        // Disable additional properties
        no_additional_properties: true,
        disable_properties: true,
        disable_edit_json: true,

        // Require all properties by default
        required_by_default: true
      });

      // Update Data
      function updateData() {
        var dataNew = editor.getValue(); // check if editor is empty
        id = Number(pw.substr(2));
        // console.log(dataNew[0]);
        // if (id === false) {
        //         data.concat(dataNew[0]);
        //     };

        if (id !== false) {
          if (dataNew.length > 0) {
            // Data Update
            data[id] = dataNew[0];
            console.log("data got updated: " + JSON.stringify(data[id]));
          } else if (dataNew.length == 0) {
            // Path deleted
            data[id] = null;
          }
        }
        // data = data.filter(function (el) {
        //     return el != null;
        // });
        console.log("data updated");
      }

      // Hide editor overlay and save data to server
      function updateGrid() {
        // updateData();
        // console.log('id: ' + id + ', data: ' + JSON.stringify(editor.getValue()))

        saveData();
        redrawGrid();
      }

      // Purge grid
      function redrawGrid() {
        // if (id || id === 0){
        //     console.log('edit id: ' + id);
        //     var element = document.getElementById(id);
        //     element.parentNode.removeChild(element);
        //     var toClean = document.getElementsByClassName(id)
        //     for (var i = 0; i < toClean.length; i++){
        //     toClean[i].innerHTML = null;
        //     }
        // };
        gridRowsRegion = [];
        var reset =
          '<h1 class="grid-title">Projektionswege</h1><div id="addpath" onclick="addPath();" class="grid-button-add ">Add Path</div></div>';
        document.getElementById("page-wrapper").innerHTML = reset;
        getVegetationshöhenstufen();
        gridRows();
        drawGrid();
        console.log("grid redrawn");
      }

      // Edit Data
      function editData(event) {
        var target = event.target || event.srcElement;
        pw = target.id;
        id = Number(pw.substr(2));
        document.getElementById("page-wrapper").classList.add("blur");
        document.getElementById("overlay").style.display = "block";
        document.getElementById("overlay-editor").style.display = "block";
        console.log("edit id: " + id);
        editor.setValue();
        editor.setValue(data[id]);
      }

      // Save and upload to projektionswege.json
      var xhttp = new XMLHttpRequest();
      var urlUpload = "../api/editor-pw-update";

      function saveData() {
        // console.log("I sent: " + JSON.stringify(data));
        xhttp.onreadystatechange = function() {
          if (this.readyState == 4 && this.status == 200) {
            console.log(xhttp.responseText);
          }
        };
        var dataClean = data.filter(function(el) {
          return el != null;
        });
        data = dataClean;

        xhttp.open("POST", urlUpload, true);
        xhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        xhttp.send(JSON.stringify(dataClean)); //dataClean
        // console.log('User sent: ' + JSON.stringify(dataClean)); //dataClean
        console.log("data saved"); //dataClean
      }

      // Validation Indicator of the JSON in the editor
      editor.on("change", function() {
        // Get an array of errors from the validator

        updateData();
        id = data.length + 1;

        var errors = editor.validate();

        var indicator = document.getElementById("valid_indicator");

        // Not valid
        if (errors.length) {
          indicator.style.color = "red";
          indicator.textContent = "not valid";
        }
        // Valid
        else {
          indicator.style.color = "green";
          indicator.textContent = "valid";
        }
      });

      // Add Segment
      function addPath() {
        document.getElementById("page-wrapper").classList.add("blur");
        document.getElementById("overlay").style.display = "block";
        document.getElementById("overlay-editor").style.display = "block";
        editor.setValue();
      }

      // // Button: Add Segment
      //             document.getElementById('addpath').addEventListener('click', function(){
      //                 console.log('add-buttonium has been pushed');
      //                 id = false;
      //                 addPath();
      //             });

      // Button: Update Segment
      document.getElementById("overlay").addEventListener("click", function() {
        updateGrid();
        document.getElementById("page-wrapper").classList.remove("blur");
        document.getElementById("overlay").style.display = "none";
        document.getElementById("overlay-editor").style.display = "none";
      });
    </script>
  </body>
</html>
